

// source: https://en.cppreference.com/w/cpp/language/operator_comparison

#include <compare>
#include <iostream>

void print(double a, double b) {
    auto res =  a <=> b;
    std::cout << a;
    if (res < 0)
        std::cout << " less than ";
    else if (res == 0)
        std::cout << " equal ";
    else if (res > 0)
        std::cout << " greater than ";
    else
        std::cout << " not comparable to ";
    std::cout << b << "\n";
}

int main() {
    double z1 = -0.0;
    double z2 = 0.0;
    double i1 = 1.0/0.0;
    double i2 = -1.0/0.0;
    double n1 = 0.0/0.0;
    double n2 = -0.0/0.0;

    print(z1,z2);
    print(i1,i2);
    print(n1,i2);
    print(n1,n2);
}
