
#include <map>
#include <string>
#include <algorithm>
#include <iostream>

// TODO C++20  string_view for *_desc (simple no-alloc solution)
void print_map(const auto &map, const std::string k_desc = "key", const std::string v_desc = "value") {
    for(const auto &[key,value] : map) { /// "structured binding" (C++17)
        std::cout << k_desc << ": \"" << key << "\" "
                  << v_desc << ": "   << value << "\n";
    }
}

int main()
{
#if 1
    std::map<std::string,int> m { {"aaa",1}, {"bbb",2}, {"ccc",3}, };
#else
    std::map<const char *,int> m { {"Caaa",1}, {"Cbbb",2}, {"Cccc",3}, };
#endif
    print_map(m);
}
