
// inspired by
// http://en.cppreference.com/w/cpp/algorithm/reduce

#include <iostream>
#include <chrono>
#include <vector>
#include <numeric>

int main()
{
    // initialize vector
    std::vector<double> v(10000000, 0.1);
    // START
    auto t1 = std::chrono::high_resolution_clock::now();
    // WORK
    double result = std::accumulate(v.begin(), v.end(), 0.0);
    // STOP
    auto t2 = std::chrono::high_resolution_clock::now();
    // how much time the WORK took
    std::chrono::duration<double, std::micro> us = t2 - t1;
    std::cout << std::fixed << "std::accumulate() = " << result
              << " took " << us.count() << " us\n";

    // evaluate overhead
    auto t3 = std::chrono::high_resolution_clock::now();
    auto t4 = std::chrono::high_resolution_clock::now();
    std::chrono::duration<double, std::micro> us2 = t4 - t3;
    std::cout << "no-op took " << us2.count() << " us\n";
}
