
#include <iostream>
#include <array>

template<class T>
void test(T t)
{
    const size_t sz = std::tuple_size<T>::value; // known at compile time
    std::cout << sz << '\n';
    int a[sz];
    // using a[] ...
}

int main()
{
    std::array<float, 3> arr;   // uninitialized
    std::array<float, 3> a2;    // uninitialized

    test(arr);          // std::tuple_size is compatible with std::array

    if( arr.size() == a2.size() ) {
        if( arr == a2 )         // lexicographical compare
            std::cout << "equal\n";
        else
            std::cout << "not equal\n";
    }
    // access
    std::get<0>(arr) = 0;       // compile-time check
    arr[1] = 1;                 // no check
    arr.at(2) = 2;              // run-time check

    std::swap(arr,a2);          // complexity O(N)

    for(auto x: a2)
        std::cout << x << " ";
    std::cout << "\n";
}

