
#include <list>
#include <algorithm>
#include <iostream>

std::ostream& operator<<(std::ostream& ostr, const std::list<int>& list)
{
    for (auto &i : list) {
        ostr << " " << i;
    }
    return ostr;
}

int main() {
    std::list<int> l1 = {5,1,2,3};
    std::list<int> l2 = {5,1,2,3};

    if(l1==l2) {
        std::cout << "l1==l2\n";
    }

    std::swap(l1,l2);

    if(l1==l2) {
        std::cout << "l1==l2\n";
    }

    l1.sort();
    l2.sort();
    l1.merge(l2);

    std::cout << '\n';
    std::cout << "l1=" << l1 << '\n';
    std::cout << "l2=" << l2 << '\n';
    std::cout << '\n';
    auto pos = std::find(begin(l1),end(l1),3);
    l2.splice(begin(l2),l1,pos,end(l1));
    std::cout << "l1=" << l1 << '\n';
    std::cout << "l2=" << l2 << '\n';
    std::cout << '\n';
    l2.splice(end(l2),l1);
    std::cout << "l1=" << l1 << '\n';
    std::cout << "l2=" << l2 << '\n';
    std::cout << '\n';
    l2.reverse();
    std::cout << "l2=" << l2 << '\n';
    l2.unique();
    std::cout << "l2=" << l2 << '\n';
}
