
// struct item alignment and padding
// try: g++ -DPACK

#include <iostream>
#include <iomanip>

#ifdef PACK
#  pragma pack(1)       // use for extra compact structs (slow)
#endif
struct Test {
    char c1;
    short s;
    char c2;
    int i;
    char c3;
    long long l;
    char c4;
    char c5;
} t = { '1', -1, '2', -1, '3', -1LL, '4', '5' };

int main(void) {
    using namespace std;
    size_t i;
    const size_t sz = sizeof(struct Test);
    unsigned char *p = reinterpret_cast<unsigned char *>(&t);
    cout << "sizeof = " << sz << "\n";
    cout << "contents = {\n  ";
    for(i=0;i<sz;++i)
        cout << setw(2) << setfill('0') << hex << static_cast<int>(p[i]) << ',';
    cout << "\n}\n";
    return 0;
}
