
// inheriting constructors
// source: cppreference

#include <iostream>

struct B1 { B1(int, int) {} };

struct B2 { B2(double)   {} };

int get() { return 42; }

struct D1 : B1 {
    using B1::B1; // inherits B1(int, int)
    int x;
    int y = get();
};

void test() {
    D1 d(2, 3); // OK: B1 is initialized by calling B1(2, 3),
                // then d.x is default-initialized (no initialization is performed),
                // then d.y is initialized by calling get()

    //D1 e;          // Error: D1 has no default constructor
    std::cout << d.y << "\n";
}

struct D2 : B2 {
    using B2::B2; // inherits B2(double)
    B1 b;
};

// D2 o(1.0); // error: B1 has no default constructor

int main() { test(); }

