
#include <iostream>
#include <limits>
#include <typeinfo>

#define PRINT(x) cout << #x " = " <<  x << '\n'

#define PRINT_ALL(T) \
    cout << "\nLimits for type " #T "\n";                 \
    PRINT(numeric_limits<T>::is_specialized);           \
    PRINT(numeric_limits<T>::is_integer);               \
    PRINT(numeric_limits<T>::is_signed);                \
    PRINT(numeric_limits<T>::is_exact);                 \
    PRINT(numeric_limits<T>::is_bounded);               \
    PRINT(numeric_limits<T>::has_infinity);             \
    PRINT(numeric_limits<T>::round_style);              \
    PRINT(numeric_limits<T>::digits);                   \
    PRINT(numeric_limits<T>::digits10);                 \
    PRINT(numeric_limits<T>::radix);                    \
    PRINT(numeric_limits<T>::max_exponent);             \
    PRINT(numeric_limits<T>::max_exponent10);           \
    PRINT(numeric_limits<T>::traps);                    \
    PRINT(numeric_limits<T>::min());                    \
    PRINT(numeric_limits<T>::lowest());                 \
    PRINT(numeric_limits<T>::max());                    \
    PRINT(numeric_limits<T>::epsilon());                \
    PRINT(numeric_limits<T>::infinity());               \
    PRINT(numeric_limits<T>::signaling_NaN());          \
    PRINT( is_fundamental<T>::value);                    \
    PRINT( is_integral<T>::value);                       \
    PRINT( is_floating_point<T>::value);                 \
    PRINT( is_pointer<T>::value);                        \
    PRINT( alignment_of<T>::value);                      \
    PRINT( (is_trivially_constructible<T,int>::value));  \
    PRINT( has_virtual_destructor<T>::value);            \
    PRINT( typeid(T).name());            \
    // etc...


int main() {
    using namespace std;
    PRINT_ALL(int);
    PRINT_ALL(unsigned long long int);
    PRINT_ALL(bool);
    PRINT_ALL(double);
    PRINT_ALL(void*);
    PRINT_ALL(std::string);
//    PRINT_ALL(_Decimal64);
}
