
#include <iostream>
#include <filesystem>

#ifndef __cpp_lib_filesystem
#  error "Usage: g++ -std=c++17"
#endif
namespace fs = std::filesystem;

int main() {
    auto tmp = fs::temp_directory_path();
    std::cout << "Temp directory is " << tmp << '\n';
    auto cwd = fs::current_path();
    std::cout << "Current directory is " << cwd << '\n';
    std::cout << "is_directory(cwd) == " << is_directory(cwd) << '\n';

    fs::space_info s = fs::space(cwd);
    std::cout << ".        Capacity       Free      Available\n"
              << cwd << s.capacity << "   " << s.free << "   " << s.available  << '\n';

    // TODO: limit to first 10
    for(auto p: fs::directory_iterator("."))
        std::cout << p << '\n';

    std::cout << "=====\n";
    // TODO: print comments
    fs::path p = "/foo/bar.txt";
    std::cout << p << '\n';
    std::cout << p.is_absolute() << '\n';
    std::cout << p.extension() << '\n';
    std::cout << p.has_extension() << '\n';
    std::cout << p.filename() << '\n';
    std::cout << p.stem() << '\n';
    std::cout << p.parent_path() << '\n';
    std::cout << "=====\n";
}
