

// locale::locale
#include <iostream>       // std::cout
#include <locale>         // std::locale
#include <stdexcept>      // std::runtime_error

int main ()
{
  using namespace std;
  //locale loc;     // initialized to locale::classic()
  locale loc("");   // initialized to user locale

  try {
    loc = locale("cs_CZ.UTF8");
    // loc = std::locale(loc, "", std::locale::ctype); // LC_CTYPE
  }
  catch (const std::runtime_error &e) {
    cout << "Exception: " << e.what() << '\n';
    return 1;
  }


  cout << "Default locale:\n";
  cout << "3.14159 = " << 3.14159 << "\n";

  cout << "The selected locale is: " << loc.name() << "\n";
  cout.imbue(loc);                      // set locale for cout
  cout << "3.14159 = " << 3.14159 << "\n";

  cout << "Set locale::classic():\n";
  cout.imbue(locale::classic());        // set locale for cout
  cout << "3.14159 = " << 3.14159 << "\n";
}

