
// source: stackoverflow

#include <codecvt>
#include <iostream>
#include <locale>

std::locale utf8("en_US.UTF-8");

// Convert UTF-8 byte string to u32string
std::u32string to_u32string(std::string const& s) {
    std::wstring_convert<std::codecvt_utf8<char32_t>,char32_t> conv;
    return conv.from_bytes(s);
}

// Convert u32string to UTF-8 byte string
std::string to_string(std::u32string const& s) {
    std::wstring_convert<std::codecvt_utf8<char32_t>,char32_t> conv;
    return conv.to_bytes(s);
}

// Converts a UTF-8 encoded string to upper case
std::string tou(std::string const& s) {
    auto ss = to_u32string(s);
    for (auto& c : ss) {
        if(c>127) c = ' ';
//        c = std::toupper(c, utf8);
    }
    return to_string(ss);
}

void test_utf8(std::ostream& os) {
    os << tou("foo" ) << std::endl;
    os << tou("#foo") << std::endl;
    os << tou("ßfoo") << std::endl;
    os << tou("Éfoo") << std::endl;
}

int main() {
    test_utf8(std::cout);
}

// from stackoverflow

