
// using declaration
// some examples from C++20 draft standard

namespace A {
  int x;
}

namespace B {
  int i;
  struct g { };
  struct x { };
  void f(int) {}
  void f(double) {}
  void g(char) {}   // OK: hides struct g
}

void fun() {
  int i;
  //using B::i;     // ERROR: i declared twice
  void f(char);
  using B::f;     // OK: each f is a function
  f(3.5);         // calls B::f(double)
  using B::g;
  g('a');         // calls B::g(char)
  struct g g1;    // g1 has class type B::g
  using B::x;
  using A::x;     // OK: hides struct B::x
  x = 99;         // assigns to A::x
  struct x x1;    // x1 has class type B::x
}

namespace C {
  void f(int) {}
  void f(double) {}
  void f(char) {}
}

int main() {
  using B::f;     // B::f(int) and B::f(double)
  using C::f;     // C::f(int), C::f(double), and C::f(char)
  f('h');         // calls C::f(char)
  //f(1);           // ERROR: ambiguous: B::f(int) or C::f(int)?
  //void f(int);    // ERROR: f(int) conflicts with C::f(int) and B::f(int)
}

