// ctrdtr2.cc -- konstruktory a destruktory 2
//

#include <iostream>
using namespace std;

class X {
  static int n0;                // poet vytvoench objekt
  int n;                        // slo objektu
  const char *const name;       // jmno objektu
public:
  X(const char *const name);
  ~X();                         // destruktor pro tdu X
};

int X::n0 = 0;                  // inicializace statickho lenu tdy

// konstruktor
X::X(const char *const nam) : n(++n0), name(nam) {
  cout << "Konstruktor objektu " << name << "(slo "<< n << ")" << endl;
}

// destruktor
X::~X() {
  cout << "Destruktor objektu " << name << "(slo "<< n << ")" << endl;
}

X a("a");                       // globln objekt

int main() {
  X b("b");                     // lokln (automatick) objekt
  X *ptr = new X("*ptr");       // dynamicky vytvoen objekt
  // ...
  delete ptr;                   // rume dynamick objekt (zkuste vynechat)
  return 0;
} // vol se destruktor objektu b

