// glist.cc -- generick seznamy s typovou kontrolou

#include <iostream>
using namespace std;

class Glist {                   // tda definujc obecn seznam
  class ListItem {              // vnoen tda -- prvek seznamu
    void *objptr;
    ListItem *next;             // ukazatel na dal prvek
   public:
    ListItem(void *o=0, ListItem *n=0) { objptr=o; next=n; }
    void *Obj() { return objptr; }
  };
  ListItem *first;              // prvn prvek seznamu
 public:
  Glist() { first=0; }          // inicializace -- przdn seznam
  void Insert(void *);          // vloen prvku
  void *First() const;          // prvn prvek
  // ...
};

void Glist::Insert(void *p) {   // na prvn msto
  ListItem *x = new ListItem(p,first);
  first = x;
}

void *Glist::First() const {
  if(first) return first->Obj();
  else      return 0;
}

// tda List<T> -- homogenn seznam s typovou kontrolou

template<class T>
class List : public Glist {  // dd obecn seznam
 public:
  void Insert(T *t)  { Glist::Insert(t); }
  T *First() const   { return (T *)Glist::First(); }
};

class Integer {
  int i;
 public:
  Integer(int x=0) : i(x) {}
  void Print() const { cout << i << '\n'; }
};

class Real {
  double r;
 public:
  Real(double x=0) : r(x) {}
  void Print() const { cout << r << '\n'; }
};

class String {
  char *s;
 public:
  String(char *x="") : s(x) {}
  void Print() const { cout << s << '\n'; }
};

List<Integer> ilist;  // vytvo tdu a instanci tto tdy
List<Real>    rlist;
List<String>  slist;

int main() {
  ilist.Insert(new Integer(10));
  ilist.Insert(new Integer(20));
  ilist.Insert(new Integer(30));
  rlist.Insert(new Real(3.14));
  rlist.Insert(new Real(2.7));
  slist.Insert(new String("text1"));
  slist.Insert(new String("text2"));

  ilist.First()->Print();       // tisk prvnho prvku seznamu
  rlist.First()->Print();
  slist.First()->Print();

  return 0;
}

