// inherit.cc -- test ddinosti, voln konstruktor
//
// hierarchie td:
//   Number
//     Integer
//       Interval

#include <iostream>
#include <cstdlib>
using namespace std;

void error(char *s) {  // funkce pro hlen chyb
  cerr << "Error: " << s << endl;
  exit(1);
}

class Number {       // bzov tda
};

class Integer : public Number {                  // tda celch sel
  int n;  // hodnota sla
 public:
  Integer(int i=0) { n=i; }                      // inicializace
  int SetValue(int i) { return n=i; }            // nastaven hodnoty
  int operator = (int i) { return SetValue(i); }
  int GetValue() const { return n; }             // zskn hodnoty
  operator int () const { return GetValue(); }   // kompatibilita s int
};

class Interval : public Integer { // tda interval z celch sel
  int min, max;  // meze intervalu
  void RangeCheck( int i ) {                // test rozsahu
    if (i<min || i>max) error("Range check");
  }
 public:
  Interval(int _min, int _max) {            // konstruktor
    SetRange(_min,_max);
    SetValue(_min);
  }
  Interval(int _min, int _max, int init) {  // konstruktor a inicializace
    SetRange(_min,_max);
    SetValue(init);
  }
  void SetRange(int _min, int _max) {       // nastaven rozsahu
    if(_min>=_max) error("Bad interval");
    min = _min;
    max = _max;
  }
  int Min() const { return min; }           // zskn mez
  int Max() const { return max; }
  int SetValue(int i) {                     // nastaven hodnoty
    RangeCheck(i);
    return Integer::SetValue(i);            // voln zddn metody
  }
  int operator = (int i) {
    return SetValue(i);
  }
};

class Point {
  Interval x;  // lokln objekty - souadnice
  Interval y;
 public:
  Point(int _x, int _y) : x(0,100,_x), y(0,100,_y) {} // voln konstruktor
  int X() { return x; }
  int Y() { return y; }
};

int main() {  // testovn ...
  Point a(10,20);
  Point b(30,40);
  Interval i(0,80);
  Interval j(1,100,70);
  Interval k(j);                  // implicitn copy konstruktor
  k = i = j;
  int v = i - 50;
  k = v;
  cout << "i = "   << i.GetValue() << endl;  
  cout << "k = "   << int(k)       << endl;        
  cout << "b.x = " << b.X()        << endl;
  return 0;
}
