// max.cc -- ablony funkc, generick funkce (function templates)

#include <cstring>

// ablony: 

template <class T>
T max(T x, T y) {               // ablona funkce max
    return (x > y) ? x : y;
}

template <class T>
T *max(T * x, T * y) {          // sten specializace ablony funkce max
    return (*x > *y) ? x : y;
}

template <class T>
const T *max(const T * x, const T * y) { // dal sten specializace
    return (*x > *y) ? x : y;
}

// funkce:

const char *max(const char *x, const char *y) {   // speciln ppad
  return (std::strcmp(x,y)>0) ? x : y;
}

char *max(char *x, char *y) {   // dal speciln ppad
  return (std::strcmp(x,y)>0) ? x : y;
}

// test:

class MyClass { // pokusn tda
  int i;
 public:
  MyClass(int x=0) : i(x) {}
  // mus bt definovn opertor >
  bool operator > (MyClass x) { return i > x.i; }
};

int main() {
  int i, j;                // neinicializovan promnn
  MyClass a, b, m, *ptr;
  const char *s1="abc";
  const char *s2="qwerty";
  const char *s3;

  j  = max(i,0);           // typ int
  m  = max(a,b);           // typ MyClass
  ptr = max(&a,&b);        // typ MyClass*
  s3 = max(s1,s2);         // typ string

  return 0;
}

void f(int i, char c) {
  max(i,i);  // vol max(int,int)
  max(c,c);  // vol max(char,char)
//  max(i,c);  // nen funkce max(int,char)  - CHYBA!
//  max(c,i);  // nen        max(char,int)  - CHYBA!
}
