// scomplex.cc -- petovn opertor
//
// program provdjte po krocch
//

#include <iostream>
using namespace std;

class Complex { // jednoduch tda komplexnch sel
  double real, imag;
 public:
  Complex() { real = imag = 0; }
  Complex(double r, double i=0) { real = r; imag = i; }
  // opertory zapsan jako metody:
  Complex operator - () {
    return Complex(-real,-imag);
  }
  Complex operator - (Complex c2) {
    return Complex(real - c2.real, imag - c2.imag);
  }
  // opertory zapsan jako friend funkce:
  friend Complex operator +(const Complex &c) { // unrn +
    return Complex(c.real, c.imag);
  }
  friend Complex operator +(const Complex &c1, const Complex &c2) {
    return Complex(c1.real + c2.real, c1.imag + c2.imag);
  }
  friend ostream & operator << (ostream &s, const Complex c) {
    return s << '(' << c.real << ',' << c.imag << ')' ;
  }
};


int main() {
    Complex  a(0,1),
             b(1,0);
    Complex  c;

    b = +b;  // unrn opertory
    a = -a;

    c = a + b;                    // opertor +
    c = operator + (a,b);         // je ekvivalentn

    c = a - b;                    // opertor -
    c = a.operator -(b);          // je ekvivalentn

    c = a + 5;                    // implicitn konverze Complex(5)
    c = a - 5;

    c = 5 + b;                    // opertor + je symetrick
//    c = 5 - b;                    // opertor - je asymetrick (metoda)

    cout << "c = " << c << endl;  // vstup

    return 0;
}
