
// string operations

#include <iostream>
#include <iomanip>              // quoted

#include <string>
#include <algorithm>            // replace, replace_copy
#include <iterator>             // back_inserter

int main() {
    using namespace std;
    string s1{"bla-bla-bla"};

    // append output to another string
    string s2;                  // empty s2
    replace_copy(begin(s1),end(s1),back_inserter(s2),'-','_');
    cout << s2 << '\n';

    // output to stream
    ostream_iterator<char> out{cout,""};
    replace_copy(begin(s1),end(s1),out,'-','_');
    cout << '\n';

    // in situ
    replace(begin(s1),end(s1),'-','_');
    cout << s1 << '\n';

    string s3{R"(a\"b\\c\td)"};    // C++11 raw string literal
    string s4{"a\"b\\c\td"};
    cout << s3 << "\t";
    cout << quoted(s3) << '\n';    // C++14 std::quoted
    cout << s4 << "\t";
    cout << quoted(s4) << '\n';    // C++14
}
