
// Demo of C++ threads
// Needs linking with -lpthread
// Source: Stroustrup talk, C++11 style, 2012-02

#include <thread>
#include <future>
#include <vector>
#include <iostream>
#include <algorithm>

using vec = std::vector<int>;

long f(const vec &v) {
    long sum = 0;
    for_each(begin(v),end(v),[&sum](int x){sum+=x;});
    return sum;
}

long g(const vec &v) {
    long sum = 0;
    for_each(begin(v),end(v),[&sum](int x){sum+=x;});
    return sum;
}

int main() {
    vec v(300'000'000,1);
    // ...
    auto res1 = std::async(f,v);
    auto res2 = std::async(g,v);
    // ...
    std::cout << res1.get() << " " << res2.get() << "\n";
}

